601bde74399fc2cef1c8ac44a961dd94c14db876
[rip_dvd/.git] / rip_dvd
1 #!/bin/bash
2 #
3 # Author: Alan J. Pippin (apippin@pippins.net)
4 # Date: 05/17/2009
5 #
6   REV=2.0
7 #
8 # Description: This script wraps a number of linux utilities to
9 # create a recipe for ripping protected DVDs, circumventing 
10 # ARcoSS and CRC checksum error protection schemes used on many
11 # newer DVDs. Edit as appropriate for your needs. I use this to
12 # backup DVDs I own, and do not condone any other activity it
13 # may be used for.
14 #
15 # Known Issues/Limitations:
16 # - Mirror mode is always done in ISO mode
17 #
18 # Package Dependencies (apt-get install these for example):
19 # lsdvd dvdauthor gddrescue dvdbackup tovid mencoder mplayer genisoimage libdvdcss2
20 #
21 # Specific Executable (program) Dependencies (must be found in $PATH):
22 # volname makexml lsdvd dvdauthor gddrescue dvdbackup mencoder mplayer mkisofs HandBrakeCLI
23 #
24 # Optional Dependencies:
25 # lookup imdb info/posters for mythvideo: http://www.mythtv.org/wiki/Fill_mythvideo_metadata.pl
26 #
27
28 ##############################################################################################
29 # Global Variables
30 ##############################################################################################
31 typeset cmd="$0 $*"
32 typeset dvdname=""
33 typeset debug=""
34 typeset dest=""
35 typeset isofile=""
36 typeset vobfile=""
37 typeset dvdpath=""
38 typeset aspect=""
39 typeset SCALE=""
40 typeset CROP=""
41 typeset profile="xvidvhq"
42 typeset extension=""
43 typeset mailto=""
44 typeset encoder=""
45 typeset default_alang="en"
46 typeset track=""
47 typeset -i default_aid=128
48 typeset -i aid_override=-1
49 typeset -i force_onepass_mode=0
50 typeset -i eject_disk=1
51 typeset -i keep_isofile=0
52 typeset -i keep_vobfile=0
53 typeset -i keep_dvdfolder=0
54 typeset -i keep_intermediate_files=0
55 typeset -i make_final_dest_vob=0
56 typeset -i make_final_dest_iso=0
57 typeset -i make_final_dest_folder=0
58 typeset -i make_final_dest_comp=0
59 typeset -i errors=0
60 typeset -i show_usage=0
61 typeset -i mirror_mode=0
62 typeset -i target_bitrate=2000
63 typeset -i target_size=0
64 typeset -i audio_2ch=0
65 typeset -i audio_6ch=1
66 typeset -i invalid_feature_title=0
67 typeset -i feature_title_override=0
68 typeset -i mplayer_dumpstream_incompatibility=0
69
70 ##############################################################################
71 # Local Machine Settings:
72 # Sources both the "default" conf file tracked by GIT (rip_dvd.conf.dist)
73 # and the local conf file created by each local machine (rip_dvd.conf)
74 # Copy the rip_dvd.conf.dist file to rip_dvd.conf and edit the later.
75 # This will allow you to override all the default values to meet your needs
76 # in a way that won't get clobbered when you pull updates from my GIT repo.
77 ##############################################################################
78 config="${0%/*}/rip_dvd.conf"
79
80 # The config file will be searched for in the following location order:
81 found_config=0
82
83 # 1) /path/to/rip_dvd/script/rip_dvd.conf.dist
84 [ -e "${config}.dist" ] && found_config=1 && . "${config}.dist"
85
86 # 2) /path/to/rip_dvd/script/rip_dvd.conf
87 [ -e "${config}" ] && found_config=1 && . "${config}"
88
89 # 3) /etc/rip_dvd.conf
90 [ -e "/etc/rip_dvd.conf" ] && found_config=1 && . "/etc/rip_dvd.conf"
91
92 # 4) $PWD/rip_dvd.conf
93 [ -e "$PWD/rip_dvd.conf" ] && found_config=1 && . "$PWD/rip_dvd.conf"
94
95 # Check to make sure we found the config file
96 if [ $found_config -eq 0 ]; then
97   echo "-E- Unable to find the rip_dvd.conf file: $config"
98   exit 1
99 fi
100
101 ##############################################################################################
102 # Command line processing
103 ##############################################################################################
104 while (($#)) && getopts 162wmvifkzx:ht:n:d:b:s:t:a:p:e:j:l: opt "$@"
105 do
106     case $opt in
107         (n)     dvdname=$OPTARG;;
108         (d)     dest=$OPTARG;;
109         (b)     target_bitrate=$OPTARG;;
110         (s)     target_size=$OPTARG;;
111         (2)     audio_2ch=1;;
112         (6)     audio_6ch=1;;
113         (1)     force_onepass_mode=1;;
114         (v)     make_final_dest_vob=1;;
115         (i)     make_final_dest_iso=1;;
116         (f)     make_final_dest_folder=1;; 
117         (z)     make_final_dest_comp=1;;
118         (e)     encoder=$OPTARG;;
119         (m)     mirror_mode=1;;
120         (k)     keep_intermediate_files=1;;
121         (t)     feature_title_override=$OPTARG;;
122         (a)     aspect=$OPTARG;;
123         (p)     profile=$OPTARG;;
124         (x)     extension=$OPTARG;;
125         (j)     eject_disk=$OPTARG;;
126         (l)     aid_override=$OPTARG;;
127         (w)     set -x;;
128         (h)     show_usage=1;;
129         (:)     echo >&2 "$0: $OPTARG requires a value"; errors=errors+1;;
130         (\?)    echo >&2 "$0: invalid option '$OPTARG'"; errors=errors+1;;
131     esac
132 done
133
134 shift $((OPTIND-1))
135
136 function usage() {
137     echo >&2 "Usage: ${0##*/} -d <destdir> [ <options> ]"
138     echo >&2 "Revision $REV"
139     echo >&2 "Options:"
140     echo >&2 "   -d <destdir>  Specify the destination directory to store the ripped DVD to"
141     echo >&2 "   -n <dvdname>  Specify a path to a DVD folder or file to process:"
142     echo >&2 "                 1) If this option is not specified, the DVD will be ripped from $dev"
143     echo >&2 "                 2) If dvdname is a full path to a DVD folder, it will be ripped as a DVD instead of $dev"
144     echo >&2 "                 3) If dvdname is a full path to an MPG2 file, it will be ripped as a DVD instead of $dev"
145     echo >&2 "                 4) If dvdname is a full path to an ISO file, it will be ripped as a DVD instead of $dev"
146     echo >&2 "                 5) If dvdname is a full path to a VOB file, it will be ripped as a DVD instead of $dev"
147     echo >&2 "   -p <profile>  Specify which encoding profile to use in -x mode as shown below:"
148     echo >&2 "                 Mencoder and Handbrake Encoder Profiles:"
149     echo >&2 "                 - xvidvhq = AVI, very high quality encoding, Xvid codec, 2 pass encoding (default)"
150     echo >&2 "                 - xvidhq = AVI, high quality encoding, Xvid codec, 2 pass encoding"
151     echo >&2 "                 - xvid = AVI, fast encoding, Xvid codec, 2 pass encoding"
152     echo >&2 "                 - iphone = MP4, x264 codec, 2 pass encoding, forced 480:320 scaling"
153     echo >&2 "                 - ipod = MP4, x264 codec, 2 pass encoding, forced 320:240 scaling"
154     echo >&2 "                 Handbrake Only Encoder Profiles:"
155     echo >&2 "                 - mp4vhq = MP4, very high quality encoding, x264 codec, 2 pass encoding"
156     echo >&2 "                 - mp4hq = MP4, high quality encoding, x264 codec, 2 pass encoding"
157     echo >&2 "                 - mp4 = MP4, fast encoding, x264 codec, 2 pass encoding"
158     echo >&2 "                 - hb_<profile> = Any predefined HandBrake profile"
159     echo >&2 "   -x <ext>      Specify a suffix extension to apply to the end of the final image filename (like .xvid, .ipod, etc)"
160     echo >&2 "                 If you run multiple instances of this script ripping the same DVD, you need to specify this option."
161     echo >&2 "   -m            Make a mirror image of the DVD and save it as a DVD ISO file"
162     echo >&2 "                 The default operation is non-mirror mode where only the main"
163     echo >&2 "                 feature title will be ripped."
164     echo >&2 "   -v            Make the final image a DVD VOB file"
165     echo >&2 "   -i            Make the final image a DVD ISO file"
166     echo >&2 "   -f            Make the final image a DVD folder"
167     echo >&2 "   -z            Make the final image a compressed file based on your profile selection and encoder"
168     echo >&2 "   -e <encoder>  Specify the encoder to use to make the compressed file (valid encoders=mencoder|handbrake) (default=handbrake if found)"
169     echo >&2 "                 You must also specify the target size or bitrate using the '-s' or '-b' options"
170     echo >&2 "   -s <size>     Set the target size of the compressed file in MB (ex: 700, 1000, etc)"
171     echo >&2 "   -b <bitrate>  Set the bitrate desired in the compressed file in kbits/sec (ex: 1500, 2000 (default), etc)"    
172     echo >&2 "   -a <W:H>      Specify the width x height aspect ratio to scale the DVD to (only used in -x mode)"
173     echo >&2 "      <W>        If only the width is given, it will autoset the height to a value which preserves the aspect ratio"
174     echo >&2 "                 The default behavior is autoaspect mode, which preserves the original aspect, with no scaling being done"
175     echo >&2 "   -j <n>        Eject the disk:"
176     echo >&2 "                 - 0 = do not eject the disk"
177     echo >&2 "                 - 1 = eject after the entire script is done (default)"
178     echo >&2 "                 - 2 = eject after the disk is no longer needed (prior to starting the encode process)"
179     echo >&2 "                 The last option will allow you to start ripping another disk while the encoding process is running on a previous"
180     echo >&2 "   -1            Force 1-pass encoding mode across all profiles"
181     echo >&2 "   -2            Use 2 channel MP3 audio encoding when making a compressed file (default is 6 channel AC3)"
182     echo >&2 "   -6            Use 6 channel AC3 audio encoding when making a compressed file (default)"
183     echo >&2 "   -k            Keep the intermediate files (good for debugging)"
184     echo >&2 "                 In -x mode, run with this option to keep the original .VOB file"
185     echo >&2 "                 By default, all intermediary files are deleted. Only the final image is kept"
186     echo >&2 "   -l <aid>      Specify the audio AID language ID to rip from the source DVD"
187     echo >&2 "   -t <title>    Specify the main feature title to pull from the DVD (only required if this script can't figure it out)"
188     echo >&2 "   -w            Set the sh Execute/Verbose flag (causes every command to be echoed)"
189     echo >&2 ""
190     exit 2
191 }
192
193 if (($errors)) || (($show_usage))
194 then
195   usage
196 fi
197
198 # Sanity Check - Command Line Options 
199 if [ "$dest" == "" ]; then
200   echo "-E- You must specify a destination directory with '-d'" | tee -a $logfile
201   usage
202 fi
203
204 if ([ $target_size -ne 0 ] || [ "$aspect" != "" ]) && [ $make_final_dest_comp -ne 1 ]; then
205   echo "-E- You can't specify a target_size, or aspect in non compressed file mode. You must specify '-x' when using '-b' or '-s' or '-a'" | tee -a $logfile
206   usage
207 fi
208
209 if [ $target_bitrate -eq 0 ] && [ $target_size -eq 0 ] && [ $make_final_dest_comp -eq 1 ]; then
210   echo "-E- You must specify a bitrate in compressed file mode. You must specify '-b' or '-s' when using '-x'" | tee -a $logfile
211   usage
212 fi
213
214 if [ $make_final_dest_vob -eq 0 ] && [ $make_final_dest_iso -eq 0 ] && 
215    [ $make_final_dest_folder -eq 0 ] && [ $make_final_dest_comp -eq 0 ] && [ $mirror_mode -eq 0 ]; then
216   echo "-E- You must specify what type of final destination you want: '-m' or '-v' or '-i' or '-f' or '-z'" | tee -a $logfile
217   usage
218 fi
219
220 if [ $mirror_mode -eq 1 ]; then
221   if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_iso -eq 1 ] || 
222      [ $make_final_dest_folder -eq 1 ] || [ $make_final_dest_comp -eq 1 ]; then
223     echo "-E- You can't specify '-v' or '-i' or '-f' or '-x' when operating in mirror mode with '-m'" | tee -a $logfile
224     usage
225   fi
226 fi
227
228 # Make handbrake the default encoder if not specified and we can find it
229 if [ -z "$encoder" ]; then
230   encoder="mencoder"; # If we can't find handbrake, set mencoder as the default
231   [[ -x `which $handbrake_xvid` ]] && [[ "$profile" =~ "xvid" ]] && encoder="handbrake";
232   [[ -x `which $handbrake_mp4` ]] && [[ "$profile" =~ "mp4" ]] && encoder="handbrake";
233   [[ -x `which $handbrake_mp4` ]] && [[ "$profile" =~ "hb" ]] && encoder="handbrake";
234 fi
235
236 # Sanity check the profile selection
237 if [[ "$encoder" == "mencoder" ]]; then
238   [[ "$profile" =~ "mp4" ]] && echo "-E- invalid encoder $encoder selected for mp4 profile: $profile" && exit
239 fi
240
241 if [[ "$encoder" != "mencoder" ]] && [[ "$encoder" != "handbrake" ]]; then
242   echo "-E- Invalid encoder specified: $encoder"
243   exit 1
244 fi
245
246 # If the aspect ratio option was specified, set the scale variable appropriately for mencoder
247 if [ "$aspect" != "" ]; then
248   echo "$aspect" | grep -q "x"
249   if [ $? == 0 ]; then
250     echo "-E- You must specify the aspect option with a value whose format is W:H"
251     exit 1
252   fi
253   echo "$aspect" | grep -q ":"
254   if [ $? != 0 ]; then
255     SCALE=",scale -zoom -sws 9 -xy $aspect"
256   else
257     SCALE=",scale=$aspect"
258   fi
259 fi
260
261 # Sanity Check - Key executables
262 [[ ! -x `which lsdvd` ]] && echo "-E- missing dependency: lsdvd" && exit
263 [[ ! -x `which volname` ]] && echo "-E- missing dependency: volname" && exit
264 [[ ! -x `which ddrescue` ]] && echo "-E- missing dependency: ddrescue" && exit
265 [[ ! -x `which dvdbackup` ]] && echo "-E- missing dependency: dvdbackup" && exit
266 [[ ! -x `which mencoder` ]] && echo "-E- missing dependency: mencoder" && exit
267 [[ ! -x `which makexml` ]] && echo "-E- missing dependency: makexml" && exit
268 [[ ! -x `which dvdauthor` ]] && echo "-E- missing dependency: dvdauthor" && exit
269 [[ ! -x `which mkisofs` ]] && echo "-E- missing dependency: mkisofs" && exit
270 [[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "xvid" ]] && [[ ! -x `which $handbrake_xvid` ]] && echo "-E- missing encoder: $handbrake_xvid" && exit
271 [[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "mp4" ]] && [[ ! -x `which $handbrake_mp4` ]] && echo "-E- missing encoder: $handbrake_mp4" && exit
272 [[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "hb" ]] && [[ ! -x `which $handbrake_mp4` ]] && echo "-E- missing encoder: $handbrake_mp4" && exit
273 [[ "$encoder" == "handbrake" ]] && [[ ! -x `which ffmpeg` ]] && echo "-E- missing dependency: ffmpeg" && exit
274
275 ##############################################################################################
276
277 typeset -i ripdvd
278 if [ -z "$dvdname" ]; then
279
280   # make sure the DVD device is accessible
281   volname $dev > /dev/null 2>&1
282   if [ $? != 0 ]; then
283     echo "-E- Can't access the DVD device $dev"
284     exit 1
285   fi
286   # now capture the volume name from the device
287   dvdname=`volname $dev | awk '{ print $1 }'`
288   ripdvd=1
289
290 else 
291
292   # check to see if dvdname is a full path to a real directory
293   # if it is, set dvdname and dvdpath appropriately
294   if [ -d "$dvdname" ]; then
295     dvdpath="$dvdname"
296     dvdname=`basename "$dvdname"`
297     keep_dvdfolder=1
298     if [ -z "$dvdname" ]; then
299      echo "-E- Unable to extract dvdname from path: $dvdpath"
300      exit 1
301     fi
302     if [ ! -d "$dvdpath/VIDEO_TS" ]; then
303       echo "-E- You must supply a full path to a valid DVD folder with this option"
304       exit 1
305     fi
306   fi
307
308   # Check to see if dvdname is a full path to a file
309   if [ -f "$dvdname" ]; then
310     valid_file=0
311
312     # check to see if dvdname is a full path to an MPG2 (VOB) file
313     # if it is, set dvdname and vobfile appropriately
314     file "$dvdname" | grep -q "MPEG"
315     if [ $? == 0 ]; then
316       # It is a valid MPEG2 file, now strip the extension off our dvdname
317       vobfile="$dvdname"
318       dvdname=`basename "$dvdname"`
319       dvdname=${dvdname%.[^.]*}
320       keep_vobfile=1
321       valid_file=1
322     fi
323
324     # check to see if dvdname is a full path to an ISO file
325     # if it is, set dvdname and isofile appropriately
326     file "$dvdname" | grep -q -e "ISO" -e "UDF"
327     if [ $? == 0 ]; then
328       # It is a valid ISO file, now strip the extension off our dvdname
329       isofile="$dvdname"
330       dvdname=`basename "$dvdname"`
331       dvdname=${dvdname%.[^.]*}
332       keep_isofile=1
333       valid_file=1
334     fi    
335
336     # check to see if dvdname is a full path to an ISO file
337     # if it is, set dvdname and isofile appropriately
338     file "$dvdname" | grep -q -e "VOB"
339     if [ $? == 0 ]; then
340       # It is a valid VOB file, now strip the extension off our dvdname
341       vobfile="$dvdname"
342       dvdname=`basename "$dvdname"`
343       dvdname=${dvdname%.[^.]*}
344       keep_vobfile=1
345       valid_file=1
346     fi    
347
348     # If we didn't find a handler for the file above, complain
349     if [ $valid_file -eq 0 ]; then
350       echo "-E- Unsupported file type: $vobfile"
351       exit 1
352     fi
353
354   # Throw an error if we can't find what the -n option is pointing to
355   else 
356     echo "-E- Unable to find the directory or file specified by the '-n $dvdname' option. Please make sure the path is valid."
357     exit 1
358   fi
359
360   # Set the ripdvd flag to false since we aren't ripping a DVD disk
361   ripdvd=0
362
363   # Since we aren't ripping a DVD disk, don't eject anything either
364   eject_disk=0
365
366 fi
367
368 # remove bad characters from the dvdname
369 dvdname=${dvdname%.} # remove trailing '.' character
370
371 # add the suffix extension to the end of the dvdname
372 dvdname=$dvdname$extension
373
374 # make a "safe" dvdname (remove special characters)
375 safedvdname=`basename "$dvdname" | sed 's/[ !&*\\$?]/_/g'`
376
377 # Make sure we have a non-empty dvdname
378 if [ -z "$dvdname" ]; then
379   echo "-E- unable to determine dvdname"
380   exit 1
381 fi
382
383 # make sure our vobfile value is set
384 if [ -z "$vobfile" ]; then
385   vobfile="$dest/$dvdname.VOB"
386 fi
387
388 # set up some variables to hold various logfiles
389 logfile="$logdir/$dvdname.log"
390 passlogfile="$tmpdir/$safedvdname.log"
391 ddrescuelog=`tempfile`
392 dvdauthorlog=`tempfile`
393 encodelog=`tempfile`
394 dumplog=`tempfile`
395
396 # create the tmpdir if it doesn't already exist
397 if [ ! -d "$tmpdir" ]; then
398   mkdir -p "$tmpdir"
399   if [ $? != 0 ]; then
400     echo "-E- Unable to create the tmpdir: $tmpdir"
401     exit 1
402   fi
403 fi
404
405 # create the logdir if it doesn't already exist
406 if [ ! -d "$logdir" ]; then
407   mkdir -p "$logdir"
408   if [ $? != 0 ]; then
409     echo "-E- Unable to create the logdir: $logdir"
410     exit 1
411   fi
412 fi
413
414 ##############################################################################################
415 # cleanup functions
416 ##############################################################################################
417 cleanup() { 
418   if [ $keep_intermediate_files -eq 0 ]; then
419     [[ -e "$dvdauthorlog" ]] && rm -f "$dvdauthorlog"
420     [[ -e "$ddrescuelog" ]] && rm -f "$ddrescuelog"
421     [[ -e "$encodelog" ]] && rm -f "$encodelog"
422     [[ -e "$dumplog" ]] && rm -f "$dumplog"
423   else
424     [[ -e "$dvdauthorlog" ]] && echo "-> Keeping dvdauthor log: $dvdauthorlog" | tee -a "$logfile"
425     [[ -e "$ddrescuelog" ]] && echo "-> Keeping ddrescue log: $ddrescuelog" | tee -a "$logfile"
426     [[ -e "$encodelog" ]] && echo "-> Keeping encode log: $encodelog" | tee -a "$logfile"
427     [[ -e "$dumplog" ]] && echo "-> Keeping dump log: $dumplog" | tee -a "$logfile"
428   fi
429   echo ""
430 }
431
432 fatal_and_exit() {
433   if [[ -z "$1" ]]; then
434     msg="-E- control-c killed us"
435   else
436     msg=$1
437   fi
438   echo -e 2>&1 "$msg" | tee -a "$logfile"
439   if [[ -n "$mailto" ]]; then
440     echo -e "$msg" | mailx -s "dvd rip of $dvdname FAILED" "$mailto"
441   fi
442   keep_intermediate_files=1
443   exit 1
444 }
445
446 # Call our cleanup functions on INT and EXIT signals
447 trap fatal_and_exit INT
448 trap cleanup EXIT
449
450 ##############################################################################################
451 # processing functions
452 ##############################################################################################
453
454 # encode the vob file into a compressed file format using handbrake
455 function encode_vob_file_handbrake {
456   
457   # declare some globals
458   typeset handbrake_cli=""
459   typeset handbrake_video_encoder_opts=""
460   typeset filetype=""
461   typeset handbrake_audio_opts=""
462   typeset hb_profile=""
463
464   # Set a variable that we will use later to determine if we found a handler for $profile or not
465   typeset -i found_profile=0    
466
467   # For a given profile, to override the 2 pass behavior to be single pass,
468   # simply set the PASSES variable below to "2" instead of "1 2" inside your profile handler. 
469   # It indicates which PASS numbers to loop over. PASSES="2" means just do pass 2 => single pass mode.
470   PASSES="-2"
471
472   # Check the global force_onepass_mode. If it is set, change our variables appropriately
473   # to force 1-pass encoding across all profiles.
474   if [ $force_onepass_mode -eq 1 ]; then
475     PASSES=""
476   fi
477
478   # get our audio track from the VOB file
479   get_audio_track_from_vob "$vobfile"
480
481   # XVID profile
482   if [[ "$profile" =~ "xvid" ]]; then
483     found_profile=1
484     handbrake_cli="$handbrake_xvid"
485     final_output_file="$dest/$dvdname.avi"
486     filetype="avi"
487
488     # Very High Quality (16fps)
489     if [ "$profile" == "xvidvhq" ]; then
490       handbrake_opts[0]="-f avi"
491       handbrake_opts[1]="-b $target_bitrate"
492       handbrake_opts[2]="-e ffmpeg"
493       handbrake_opts[3]="-T"
494       handbrake_opts[4]="-5"
495       handbrake_opts[5]="-8"
496     fi
497     # High Quality (20fps)
498     if [ "$profile" == "xvidhq" ]; then
499       handbrake_opts[0]="-f avi"
500       handbrake_opts[1]="-b $target_bitrate"
501       handbrake_opts[2]="-e ffmpeg"
502       handbrake_opts[3]="-T"
503       handbrake_opts[4]="-5"
504     fi
505     # Fast (28fps)
506     if [ "$profile" == "xvid" ]; then
507       handbrake_opts[0]="-f avi"
508       handbrake_opts[1]="-b $target_bitrate"
509       handbrake_opts[2]="-e ffmpeg"
510       handbrake_opts[3]="-T"
511     fi
512   fi
513
514   # MP4 profile
515   if [[ "$profile" =~ "mp4" ]]; then
516     found_profile=1
517     handbrake_cli="$handbrake_mp4"
518     final_output_file="$dest/$dvdname.mp4"
519     PASSES=""
520
521     # Very High Quality
522     if [ "$profile" == "mp4vhq" ]; then
523       profile="hb_High_Profile"
524     fi
525     # High Quality
526     if [ "$profile" == "mp4hq" ]; then
527       profile="hb_Normal"
528     fi
529     # Fast
530     if [ "$profile" == "mp4" ]; then
531       profile="hb_Classic"
532     fi
533   fi
534
535   # iphone and ipod MP4 profiles
536   if [ "$profile" == "iphone" ] || [ "$profile" == "ipod" ]; then
537     found_profile=1
538     handbrake_cli="$handbrake_mp4"
539     final_output_file="$dest/$dvdname.mp4"
540     PASSES=""
541
542     # iphone
543     if [ "$profile" == "iphone" ]; then
544       profile="hb_iPhone"
545     fi
546     # ipod
547     if [ "$profile" == "ipod" ]; then
548       profile="hb_iPod"
549     fi
550   fi
551   
552   # Predefined Handbrake Profile Handling
553   if [[ "$profile" =~ "hb" ]]; then
554     found_profile=1
555     handbrake_cli="$handbrake_mp4"
556     final_output_file="$dest/$dvdname.mp4"
557     PASSES=""
558     
559     # extract the HandBrake Profile name from $profile
560     hb_profile=`echo "$profile" | sed 's/hb_//g' | sed 's/_/ /g'`
561   fi
562
563   # Make sure we found a handler for the given profile
564   if [ $found_profile -eq 0 ]; then
565     fatal_and_exit "-E- Unable to find a profile handler for profile: $profile"
566   fi
567
568   # setup our audio option
569   if [ $audio_2ch -eq 1 ] && [ $audio_6ch -eq 1 ]; then
570     handbrake_audio_opts="-E faac,ac3 -6 dpl2,none"
571   fi
572   if [ $audio_6ch -eq 1 ] && [ $audio_2ch -eq 0 ]; then
573     handbrake_audio_opts="-E ac3 -6 none"
574   fi
575   if [ $audio_2ch -eq 1 ] && [ $audio_6ch -eq 0 ]; then
576     handbrake_audio_opts="-E faac -6 dpl2"
577   fi
578   if [ -n "$track" ]; then
579     handbrake_audio_opts="$handbrake_audio_opts -a $track"
580   fi
581
582   # Convert our array of opts into a string
583   for OPTS in "${video_encoder_opts[@]}"; do 
584     handbrake_video_encoder_opts="$handbrake_video_encoder_opts:$OPTS"
585   done
586   if [ -n "$handbrake_video_encoder_opts" ]; then
587     handbrake_video_encoder_opts="-x $handbrake_video_encoder_opts"
588   fi
589   for OPTS in "${handbrake_opts[@]}"; do 
590     handbrake_cmd_line_opts="$handbrake_cmd_line_opts $OPTS"
591   done
592   
593   # Execute the handbrake command to encode the video
594   if [ -n "$hb_profile" ]; then
595     echo -e "\n   Encoding: $handbrake_cli -i \"$vobfile\" -o \"$final_output_file\" -Z \"$hb_profile\" $handbrake_cmd_line_opts $handbrake_audio_opts $handbrake_video_encoder_opts $PASSES >> $encodelog 2>&1" >> "$logfile"
596     $handbrake_cli -i "$vobfile" -o "$final_output_file" -Z "$hb_profile" $handbrake_cmd_line_opts $handbrake_audio_opts $handbrake_video_encoder_opts $PASSES >> $encodelog 2>&1
597     handbrake_retval=$?
598   else 
599     echo -e "\n   Encoding: $handbrake_cli -i \"$vobfile\" -o \"$final_output_file\" $handbrake_cmd_line_opts $handbrake_audio_opts $handbrake_video_encoder_opts $PASSES >> $encodelog 2>&1" >> "$logfile"
600     $handbrake_cli -i "$vobfile" -o "$final_output_file" $handbrake_cmd_line_opts $handbrake_audio_opts $handbrake_video_encoder_opts $PASSES >> $encodelog 2>&1
601     handbrake_retval=$?
602   fi
603   if [ $handbrake_retval != 0 ]; then
604     fatal_and_exit "-E- Unhandled handbrake error"
605   fi
606
607   # Concatenate the encode log to our main log file, greping out unwanted lines
608   cat $encodelog | grep -v "Encoding" >> "$logfile" 
609   cat $encodelog | grep "Encoding:" | sed 's/\r/\n/g' | grep "Encoding:" | grep "ETA" | head -1 >> "$logfile"
610   cat $encodelog | grep "Encoding:" | sed 's/\r/\n/g' | grep "Encoding:" | grep "ETA" | tail -1 >> "$logfile"
611 }
612
613 # encode the vob file into a compressed file format using mencoder
614 function encode_vob_file_mencoder {
615
616   # Set a variable that we will use later to determine if we found a handler for $profile or not
617   typeset -i found_profile=0
618
619   # For a given profile, to override the 2 pass behavior to be single pass,
620   # simply set the PASSES variable below to "2" instead of "1 2" inside your profile handler. 
621   # It indicates which PASS numbers to loop over. PASSES="2" means just do pass 2 => single pass mode.
622   PASSES="1 2"
623
624   # Declare our default 2 pass variables
625   passlogfile_opt="-passlogfile $passlogfile"
626   pass_opt="pass=%PASS"
627
628   # Check the global force_onepass_mode. If it is set, change our variables appropriately
629   # to force 1-pass encoding across all profiles.
630   if [ $force_onepass_mode -eq 1 ]; then
631     PASSES="2"
632     passlogfile_opt=""
633     pass_opt=""    
634   fi
635
636   # XVID profile
637   if [[ "$profile" =~ "xvid" ]]; then
638     found_profile=1
639     final_output_file="$dest/$dvdname.avi"
640     mencoder_general_opts="$lang_opts $passlogfile_opt"
641     mencoder_output_opts="-ofps 30000/1001 -ffourcc DIVX"
642     mencoder_video_filter_opts="-vf pullup,softskip,hqdn3d=2:1:2$CROP$SCALE"
643     mencoder_video_encoder_opts="-ovc xvid -xvidencopts $pass_opt"
644
645     # Very High Quality (16fps)
646     if [ "$profile" == "xvidvhq" ]; then
647       video_encoder_opts[0]="bitrate=$target_bitrate"
648       video_encoder_opts[1]="threads=$mencoder_threads"
649       video_encoder_opts[2]="chroma_opt"
650       video_encoder_opts[3]="vhq=4"
651       video_encoder_opts[4]="bvhq=1"
652       video_encoder_opts[5]="quant_type=mpeg"
653       video_encoder_opts[6]="autoaspect"
654     fi
655     # High Quality (20fps)
656     if [ "$profile" == "xvidhq" ]; then
657       video_encoder_opts[0]="bitrate=$target_bitrate"
658       video_encoder_opts[1]="threads=$mencoder_threads"
659       video_encoder_opts[2]="chroma_opt"
660       video_encoder_opts[3]="vhq=2"
661       video_encoder_opts[4]="bvhq=1"
662       video_encoder_opts[5]="quant_type=mpeg"
663       video_encoder_opts[6]="autoaspect"
664     fi
665     # Fast (28fps)
666     if [ "$profile" == "xvid" ]; then
667       video_encoder_opts[0]="bitrate=$target_bitrate"
668       video_encoder_opts[1]="threads=$mencoder_threads"
669       video_encoder_opts[2]="vhq=0"
670       video_encoder_opts[3]="turbo"
671       video_encoder_opts[4]="autoaspect"
672     fi
673
674     for OPTS in "${video_encoder_opts[@]}"; do 
675       mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
676     done
677
678     if [ $audio_2ch -eq 0 ]; then
679       # These options produce good 6 channel audio for linux and windows
680       mencoder_audio_opts="-oac copy"
681       # There are 3 different ways to specify 6 channel encoding. We'll try the other ones in order if one of them fails.
682       mencoder_audioch_opts[0]="-channels 6 -af channels=6"
683       mencoder_audioch_opts[1]="-af channels=6"
684       mencoder_audioch_opts[2]=""
685     else
686       # These options produce good 2 channel audio for linux and windows (including the internal mythvideo player)
687       mencoder_audio_opts="-oac mp3lame -lameopts cbr:br=$audio_bitrate"
688       mencoder_audioch_opts[0]=""
689     fi
690  
691   fi
692
693   # iphone and ipod MP4 profiles
694   if [ "$profile" == "iphone" ] || [ "$profile" == "ipod" ]; then
695     found_profile=1
696     if [ "$profile" == "iphone" ]; then
697       # SCALE: 480x320
698       # scale width to 480, set height appropriately, but keep a multiple of 16
699       #SCALE=",scale=480:-10"
700       # scale the video down however far is necessary to fit in 480x320
701       SCALE=",dsize=480:320:0,scale=-8:-8"
702     else
703       # SCALE: 320x240
704       # scale width to 320, set height appropriately, but keep a multiple of 16
705       #SCALE=",scale=320:-10"
706       # scale the video down however far is necessary to fit in 320x240
707       SCALE=",dsize=320:240:0,scale=-8:-8"
708     fi
709     final_output_file="$dest/$dvdname.mp4"
710     mencoder_general_opts="$lang_opts $passlogfile_opt"
711     mencoder_output_opts="-ofps 30000/1001 -sws 9 -of lavf -lavfopts format=mp4"
712     mencoder_video_filter_opts="-vf harddup$CROP$SCALE";
713     mencoder_video_encoder_opts="-ovc x264 -x264encopts $pass_opt"
714     video_encoder_opts[0]="bitrate=$target_bitrate"
715     video_encoder_opts[1]="threads=$mencoder_threads"
716     video_encoder_opts[2]="vbv_maxrate=1500"
717     video_encoder_opts[3]="vbv_bufsize=2000"
718     video_encoder_opts[4]="nocabac"
719     video_encoder_opts[5]="me=umh"
720     video_encoder_opts[6]="subq=6"
721     video_encoder_opts[7]="frameref=6"
722     video_encoder_opts[8]="trellis=1"
723     video_encoder_opts[9]="level_idc=30"
724     video_encoder_opts[10]="global_header"
725     video_encoder_opts[11]="bframes=0"
726     video_encoder_opts[12]="partitions=all"
727     for OPTS in "${video_encoder_opts[@]}"; do 
728       mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
729     done
730
731     mencoder_audio_opts="-oac faac -faacopts mpeg=4:object=2:br=$audio_bitrate:raw"
732     mencoder_audioch_opts[0]="-channels 2 -srate 48000"
733   fi
734
735   if [ $found_profile -eq 0 ]; then
736     fatal_and_exit "-E- Unable to find a profile handler for profile: $profile"
737   fi
738
739   # Do not edit this line. $mencoder_video_encoder_opts must be last
740   mencoder_opts="$mencoder_general_opts $mencoder_output_opts $mencoder_audio_opts $mencoder_video_filter_opts $mencoder_video_encoder_opts"
741   mencoder_retval=0
742
743   for PASS in $PASSES
744   do 
745     # Set some options based on which pass we are in
746     mencoder_opts_for_pass=$(echo "$mencoder_opts" | sed "s,%PASS,$PASS,g")
747     [ $PASS -eq 1 ] && mencoder_opts_for_pass="$mencoder_opts_for_pass:turbo"
748     [ $PASS -eq 1 ] && output_file="/dev/null"
749     [ $PASS -eq 2 ] && output_file="$final_output_file"
750   
751     # It's possible that the audio channel encoding may not work. Cycle through all our different audioch_opts until we find one that works.
752     for CH_OPTS in "${mencoder_audioch_opts[@]}"; 
753     do
754       echo -e "   Encoding pass $PASS"
755       echo -e "\n   Encoding pass $PASS: mencoder $CH_OPTS $mencoder_opts_for_pass \"$vobfile\" -o \"$output_file\" >> $encodelog 2>&1" >> "$logfile"
756       mencoder $CH_OPTS $mencoder_opts_for_pass "$vobfile" -o "$output_file" > $encodelog 2>&1
757       mencoder_retval=$? 
758       grep -q "\[channels\] Invalid" $encodelog
759       if [ $? != 0 ]; then          
760         break;
761       else
762         echo -e "\n-W- Audio channel encoding error. Falling back to next audio channel encoding scheme." >> "$logfile"
763       fi
764     done
765       
766     if [ $mencoder_retval != 0 ]; then
767       fatal_and_exit "-E- Unhandled mencoder error"
768     fi
769
770     # Concatenate the encode log to our main log file, greping out unwanted lines
771     cat $encodelog | grep -v "^Pos:" | grep -v "duplicate" >> "$logfile"
772
773   done
774 }
775
776 function make_dvd_iso_image {
777
778   isofile="$1"
779
780   # check to see if we have a dvdpath to rip from instead of $dev
781   if [ -z "$dvdpath" ]; then
782     # load the CSS codes in the DVD drive 
783     lsdvd $dev >> "$logfile"
784     if [ $? != 0 ]; then
785       fatal_and_exit "-E- lsdvd $dev failed" 
786     fi
787
788     # read the DVD, ignoring/skipping CRC errors
789     ddrescue -n -b 2048 $dev "$isofile" "$ddrescuelog"
790     if [ $? != 0 ]; then
791       fatal_and_exit "-E- ddrescue -n -b 2048 $dev \"$isofile\" failed"
792     fi
793     cat "$ddrescuelog" >> "$logfile"
794   else
795     # rip from a path instead
796     make_dvd_iso_image_from_folder "$dvdpath" "$isofile" 1
797   fi
798 }
799
800 function make_dvd_iso_image_from_folder {
801   
802   src="$1"
803   dst="$2"
804   handle_error=$3
805   
806   echo "-> Creating ISO image of DVD video: $src -> $dst" | tee -a "$logfile"
807
808   # make an iso image out of our directory
809   echo "   mkisofs -dvd-video \"$src\" 2>> \"$dumplog\" | dd of=\"$dst\" obs=32k seek=0 > /dev/null 2>> $dumplog" >> "$logfile"
810   mkisofs -dvd-video "$src" 2>> "$dumplog" | dd of="$dst" obs=32k seek=0 > /dev/null 2>> "$dumplog"
811
812   # set the audio languages from the iso if it exists and is non-zero in size
813   if [ -s "$dst" ]; then
814     get_feature_title "$dst"
815     get_audio_id_from_iso "$dst"
816   fi
817
818   # make sure we were able to create the iso image from the folder given to us
819   if [ ! -s "$dst" ] && [ $handle_error -eq 1 ]; then
820     echo "-> Unable to make an iso image from the DVD folder: $dvdpath"
821     echo "   Falling back to mplayer to create a main feature VOB from the folder instead: $dvdpath"
822     # remove the bad iso file
823     [[ -e "$dst" ]] && rm -f "$dst"
824     # get the feature title from the DVD folder
825     get_feature_title "$dvdpath"
826     # create our main VOB file from the ISO
827     create_main_vob_with_mplayer "$dvdpath" 
828     # get our audio id from the VOB file
829     get_audio_id_from_vob "$vobfile"
830   fi
831 }
832
833 function make_dvdbackup_folder_image {
834   # extract the feature title from the DVD image
835   echo "-> Extracting feature title using dvdbackup" | tee -a "$logfile"
836   [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
837   dvdbackup -F -i "$isofile" -o "$tmpdir" >> "$logfile"
838   if [ $? != 0 ]; then
839     fatal_and_exit '-E- dvdbackup -F -i "$isofile" -o "$tmpdir" failed'
840   fi
841 }
842
843 function make_dvdauthor_folder_image {
844   # create a new DVD video of the feature title
845   echo "-> Creating DVD video $dest/$dvdname" | tee -a "$logfile"
846   [[ -d "$dest/$dvdname" ]] && rm -rf "$dest/$dvdname"
847   dvdauthor -o "$dest/$dvdname" -x dvd.xml > $dvdauthorlog 2>&1
848   cat $dvdauthorlog | grep -v "VOBU" >> "$logfile"
849
850   # There is a chance that dvdauthor won't like some of the VOBs.
851   # We can't tell ahead of time which ones it will choke on. 
852   # So, we need to run it over and over again until it can process
853   # all the VOBs. If it can't handle one of them, run it through
854   # mencoder to fix it and try again. These errors are typically
855   # present due to the copy protection that ddrescue removed.
856   grep -q "SCR moves" $dvdauthorlog
857   while [ $? == 0 ]; do
858     # fix bad vobs that get the "SCR moves backwards" error:
859     #  STAT: Processing VTS_01_0.VOB...
860     #  ERR:  SCR moves backwards, remultiplex input.
861     badvob=`grep -v "^WARN:" $dvdauthorlog | grep -B 1 "SCR moves" | grep "Processing" | awk '{ print $3 }' | sed -e 's/\.\.\.//'`
862     if [[ ! -f "$badvob" ]]; then
863       fatal_and_exit "-E- Found a bad VOB, but could not extract it's name properly: $badvob"
864     fi
865     echo "-> Fixing SCR errors in DVD video file $badvob" | tee -a "$logfile"
866     cat $badvob | mencoder $lang_opts -quiet -of mpeg -mpegopts format=dvd -oac copy -ovc copy - -o $badvob.fixed >> "$logfile" 2>&1
867     mv -f $badvob.fixed $badvob
868     echo "-> Creating DVD video $dest/$dvdname"
869     dvdauthor -o "$dest/$dvdname" -x dvd.xml > $dvdauthorlog 2>&1
870     cat $dvdauthorlog | grep -v "VOBU" >> "$logfile"
871     grep -q "SCR moves" $dvdauthorlog
872   done
873 }
874
875 function get_feature_title {
876   source="$1"
877   # if a feature title was given on the command line, use it
878   if [ $feature_title_override -ne 0 ]; then
879     feature_title=$feature_title_override
880     return 0
881   fi
882   # otherwise, use lsdvd to figure it out
883   if [ $ripdvd -eq 1 ]; then
884     feature_title=`lsdvd $dev | awk '/Longest/ { print $NF }'`
885   else 
886     feature_title=`lsdvd "$source" 2>/dev/null | awk '/Longest/ { print $NF }'`
887   fi
888 }
889
890 function create_main_vob_with_cat {
891   # cd to the feature title DVD folder
892   pushd "$tmpdir/$dvdname/VIDEO_TS" > /dev/null 2>&1
893   if [ $? != 0 ]; then
894     fatal_and_exit "-E- Unable to cd to $tmpdir/$dvdname/VIDEO_TS"
895   fi
896
897   # concatenate all the VOBs together into 1 giant VOB
898   vobs=`/bin/ls -1 VTS*.VOB | grep -v "0.VOB" | tr '\n' ' '`
899   cat $vobs > "$tmpdir/$dvdname.VOB"
900
901   # cd back to the dir we started from
902   popd > /dev/null 2>&1
903 }
904
905 function create_main_vob_with_mplayer {
906
907   # argument processing  
908   source="$1"
909   remove_dumplog=$2
910
911   # make sure we have a valid feature title
912   if [ $invalid_feature_title -eq 1 ] && [ $feature_title_override -eq 0 ]; then
913     fatal_and_exit "-E- You must have a valid feature title to get the VOB via mplayer dumpstream. We can't determine the feature title for this DVD."
914   fi
915
916   # check to make sure we didn't detect an mplayer dumpstream incompatibility earlier
917   if [ $mplayer_dumpstream_incompatibility -eq 1 ]; then
918     msg="-E- We detected an mplayer dumpstream incompatibility earlier."
919     msg="$msg We also detected another condition that requires us to use dumpstream. "
920     msg="$msg\n    Unable to rip this DVD in the mode you requested."
921     fatal_and_exit "$msg"
922   fi
923
924   # use mplayer to create the main VOB file
925   echo "-> Using mplayer to dump the DVD feature title $feature_title to a VOB file directly: $vobfile" | tee -a "$logfile"
926   echo "   mplayer $lang_opts -dumpstream -dumpfile \"$vobfile\" -dvd-device \"$source\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
927   mplayer $lang_opts -dumpstream -dumpfile "$vobfile" -dvd-device "$source" dvd://$feature_title > $dumplog 2>&1
928   if [ $? != 0 ]; then
929     cat $dumplog | grep -v "^A:" >> "$logfile"
930     fatal_and_exit "-E- Mplayer Failed"
931   fi
932   cat $dumplog | grep -v "^A:" >> "$logfile"
933   [[ -e "$dumplog" ]] && [[ $remove_dumplog -eq 1 ]] && rm -f $dumplog
934 }
935
936 function get_audio_id_from_iso {
937   # Adjust our audio ID to find the english audio stream
938   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
939   iso="$1"
940   aidcheck=`tempfile`
941   aid=$default_aid
942   alang=$default_alang
943   if [ $aid_override -lt 0 ]; then 
944     mplayer -v -endpos 0 -dvd-device "$iso" dvd://$feature_title > $aidcheck 2>&1
945     grep -q "aid: $aid" $aidcheck
946     while [ $? == 1 ] && [ $aid -lt 159 ]; do
947       (( aid = aid + 1 ))
948       grep -q "aid: $aid" $aidcheck
949     done
950     [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
951   else
952     aid=$aid_override
953   fi
954   echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
955   # mencoder default DVD audio track language selection (english)
956   lang_opts="-aid $aid -alang $alang"
957 }
958
959 function get_crop_from_iso { 
960   FRAMES=10000
961   echo "-> Detecting black frame border crop value from ISO file"
962   echo "   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device \"$isofile\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
963   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device "$isofile" dvd://$feature_title > $dumplog 2>&1
964   [[ -e "md5sums" ]] && rm -f "md5sums"
965   CROP=`cat $dumplog | grep CROP | tail -1`
966   echo "   Found crop value of $CROP" >> "$logfile"
967   CROP=${CROP#* crop=}
968   CROP=${CROP%%\).*}
969   typeset -i CROPCHECK
970   CROPCHECK=`echo "$CROP" | awk -F ':' '{ print $1 }'`
971   echo "   Final crop value of $CROP with cropcheck value of $CROPCHECK" >> "$logfile"
972   if [ -z "$CROP" ]; then
973     echo "-W- Unable to extract CROP value from iso: $isofile" | tee -a "$logfile"
974     return
975   fi
976   if [ $CROPCHECK -lt 0 ]; then 
977     CROP=""
978   else 
979     CROP=",crop=$CROP"
980   fi
981   echo "   Setting mencoder crop filter to: $CROP"
982 }
983
984 function get_crop_from_vob { 
985   FRAMES=10000
986   echo "-> Detecting black frame border crop value from VOB file"
987   echo "   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark \"$vobfile\" > $dumplog 2>&1" >> "$logfile"
988   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark "$vobfile" > $dumplog 2>&1
989   [[ -e "md5sums" ]] && rm -f "md5sums"
990   CROP=`cat $dumplog | grep CROP | tail -1`
991   echo "   Found crop value of $CROP" >> "$logfile"
992   CROP=${CROP#* crop=}
993   CROP=${CROP%%\).*}
994   typeset -i CROPCHECK
995   CROPCHECK=`echo "$CROP" | awk -F ':' '{ print $1 }'`
996   echo "   Final crop value of $CROP with cropcheck value of $CROPCHECK" >> "$logfile"
997   if [ -z "$CROP" ]; then
998     echo "-W- Unable to extract CROP value from iso: $isofile" | tee -a "$logfile"
999     return
1000   fi
1001   if [ $CROPCHECK -lt 0 ]; then 
1002     CROP=""
1003   else 
1004     CROP=",crop=$CROP"
1005   fi
1006   echo "   Setting mencoder crop filter to: $CROP"
1007 }
1008
1009 function get_audio_track_from_vob {
1010   # Adjust our audio ID to find the english audio stream
1011   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
1012   vob="$1"
1013   aidcheck=`tempfile`
1014   aid=$default_aid
1015   alang=$default_alang
1016   if [ $aid_override -lt 0 ]; then 
1017     mplayer -v -endpos 0 "$vob" > $aidcheck 2>&1
1018     grep -q "Found audio stream: $aid" $aidcheck
1019     while [ $? == 1 ] && [ $aid -lt 159 ]; do
1020       (( aid = aid + 1 ))
1021       grep -q "Found audio stream: $aid" $aidcheck
1022     done
1023     [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
1024   else 
1025     aid=$aid_override
1026   fi
1027   # Now that we've found the right audio id, find the corresponding audio track in HandBrake
1028
1029   # convert the aid we found into hex
1030   aid_hex=`echo "obase=16; $aid" | bc`
1031   
1032   # extract the audio streams in the vob
1033   ffmpeg -i "$vob" > $aidcheck 2>&1
1034   
1035   # find the stream that matches our aid
1036   stream=`grep "Stream.*\[0x$aid_hex\]" $aidcheck`
1037  
1038   # extract the track number that handbrake uses
1039   track=`expr match "$stream" '.*#[0-9]\.\([0-9]*\)'`
1040
1041   if [ -n "$track" ]; then   
1042     echo "-> Setting the audio ID to $aid. Setting the audio track to $track." | tee -a "$logfile"
1043   fi
1044 }
1045
1046 function get_audio_id_from_vob {
1047   # Adjust our audio ID to find the english audio stream
1048   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
1049   vob="$1"
1050   aidcheck=`tempfile`
1051   aid=$default_aid
1052   alang=$default_alang
1053   if [ $aid_override -lt 0 ]; then 
1054     mplayer -v -endpos 0 "$vob" > $aidcheck 2>&1
1055     grep -q "Found audio stream: $aid" $aidcheck
1056     while [ $? == 1 ] && [ $aid -lt 159 ]; do
1057       (( aid = aid + 1 ))
1058       grep -q "Found audio stream: $aid" $aidcheck
1059     done
1060     [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
1061   else 
1062     aid=$aid_override
1063   fi
1064   echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
1065   # mencoder default DVD audio track language selection (english)
1066   lang_opts="-aid $aid -alang $alang"
1067 }
1068
1069 function check_vob_for_corrupted_start {
1070   # check to see if the beginning of the DVD has a form of copy protection
1071   # where they have deliberately broken the first X number of frames of the DVD.
1072   # If we don't skip these, our resulting VOB file will not play.
1073   badvobcheck=`tempfile`
1074   endpos=360
1075   skip=0
1076   mencoder -ss $skip -endpos $endpos $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy "$tmpdir/$dvdname.VOB" -o /dev/null > $badvobcheck 2>&1
1077   if [ $? != 0 ]; then
1078     fatal_and_exit "-E- Mencoder Failed"
1079   fi
1080   grep "Writing header" -A `wc $badvobcheck | awk '{ print $1 }'` $badvobcheck | grep -q "Too many video packets in the buffer"
1081   while [ $? == 0 ] && [ $skip -lt $endpos ]; do
1082     (( skip = skip + 5 ))
1083     echo "-> Bad VOB copy protection detected. Trying new skip value of $skip" | tee -a "$logfile"
1084     mencoder -ss $skip -endpos $endpos $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy "$tmpdir/$dvdname.VOB" -o /dev/null > $badvobcheck 2>&1
1085     if [ $? != 0 ]; then
1086       fatal_and_exit "-E- Mencoder Failed"
1087     fi
1088     grep "Writing header" -A `wc $badvobcheck | awk '{ print $1 }'` $badvobcheck | grep -q "Too many video packets in the buffer"
1089   done
1090   [[ -e "$badvobcheck" ]] && rm -f "$badvobcheck";
1091
1092   # cat the giant VOB into mencoder to create a playable VOB file
1093   cat "$tmpdir/$dvdname.VOB" | mencoder -ss $skip -quiet $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy - -o "$vobfile" >> "$logfile" 2>&1
1094   if [ $? != 0 ]; then
1095     fatal_and_exit "-E- Mencoder Failed"
1096   fi
1097 }
1098
1099 function check_vob_for_completeness {
1100   # check to make sure we got out a complete VOB.
1101   # there is another kind of copy protection where the VOB's may
1102   # have "MPG EOF" frames in the middle of the stream. 
1103   # this causes mencoder to not process the entire VOB, and exit without any errors.
1104   # detect this by seeing how much smaller the dst vob is from the src vob.
1105   MAX_FILESIZE_DELTA_PERCENT=70
1106   SRC_VOB_FILESIZE=$(stat -c%s "$tmpdir/$dvdname.VOB")
1107   DST_VOB_FILESIZE=$(stat -c%s "$vobfile")
1108   FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
1109   if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
1110     # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
1111     echo "-> Detected bad VOB size copy protection after processing concatenated VOB file." | tee -a "$logfile"
1112     create_main_vob_with_mplayer "$isofile"
1113     [[ -e "$dumplog" ]] && rm -f $dumplog
1114     DST_VOB_FILESIZE=$(stat -c%s "$vobfile")
1115     FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
1116     if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
1117       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n    I recommend using another ripping mode like '-m' or '-i'"
1118     fi
1119   fi
1120 }
1121
1122 function check_vob_for_too_many_video_packets {
1123   # If our earlier algorithm to work around this failed, throw an error.
1124   # check to see if this DVD has a protection scheme we don't know how to work around
1125   # when I tried to burn the CARS DVD for example, you can't play the resulting VOB file.
1126   # for some reason, the video is black, while the audio rolls, then the video finally comes
1127   # in, but it is WAY off the audio. This appears to be due to some bad frames at the beginning of 
1128   # the 1st VOB. Until I figure out how to work around this, detect it, and error out.
1129   # instead of pulling the image from the disk again, you can pull it directly from the iso: -dvd-device $iso_path
1130   grep -q "Too many video packets in the buffer:" "$logfile"
1131   if [ $? == 0 ]; then
1132     # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
1133     echo "-> Detected corrupt audio stream copy protection after processing concatenated VOB file." | tee -a "$logfile"
1134     create_main_vob_with_mplayer "$isofile"
1135     grep -q "Too many video packets in the buffer:" $dumplog
1136     if [ $? == 0 ]; then
1137       [[ -e "$dumplog" ]] && rm -f $dumplog
1138       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n   I recommend using another ripping mode like '-m' or '-i'"
1139     fi
1140     [[ -e "$dumplog" ]] && rm -f $dumplog
1141   fi
1142 }
1143
1144 function check_vob_for_a52_crc_errors {
1145   # Let's see if we can playback our newly created VOB file without any errors.
1146   # if there are issues, let's detect them now, and try to recreate the VOB
1147   # there are some forms of copy protection that have missed above, that evidence
1148   # themselves when we try to playback the VOB file. This was added to deal with
1149   # the "a52: CRC check failed" copy protection scheme.
1150   MAX_ERRORS=10
1151   ENDPOS=120
1152   echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
1153   mplayer -endpos $ENDPOS -ao null -vo null "$vobfile" > $dumplog 2>&1
1154   cat $dumplog | grep -v "^A:" >> "$logfile"
1155   errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
1156   if [ $errors -gt $MAX_ERRORS ]; then
1157     echo "-> Detected a52 audio stream CRC errors copy protection after processing concatenated VOB file." | tee -a "$logfile"
1158     create_main_vob_with_mplayer "$isofile"
1159     echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
1160     mplayer -endpos $ENDPOS -ao null -vo null "$vobfile" > $dumplog 2>&1
1161     if [ $? != 0 ]; then
1162       cat $dumplog | grep -v "^A:" >> "$logfile"
1163       fatal_and_exit "-E- Mplayer Failed"
1164     fi
1165     cat $dumplog | grep -v "^A:" >> "$logfile"
1166     errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
1167     if [ $errors -gt $MAX_ERRORS ]; then
1168       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n   I recommend using another ripping mode like '-m' or '-i'"
1169     fi
1170   fi
1171   [[ -e "$dumplog" ]] && rm -f $dumplog
1172 }
1173
1174 function calculate_bitrate_from_target_size {
1175   # determine what our bitrate needs to be if a target size was specified instead
1176   if [ $target_size -ne 0 ]; then
1177     vob_length=`mplayer -identify -v "$vobfile" -endpos 0 2>&1 | grep ID_LENGTH | awk -F '=' '{ print $2 }' | awk -F '.' '{ print $1 }'`
1178     ((target_bitrate = (target_size * 1024 * 8) / vob_length ))
1179     echo "   With a given target size of $target_size MB, the estimated bit rate will need to be $target_bitrate kbits/sec"
1180   fi
1181 }
1182
1183 function create_dvdauthor_dvd_xml_file {
1184   # make a dvdauthor xml menu file to create a valid DVD video from 
1185   # this script does a good job, but we'll still need to clean it up a bit after it runs
1186   echo "-> Creating dvdauthor XML menu file" | tee -a "$logfile"
1187   makexml -overwrite -dvd *.VOB -out dvd >> "$logfile" 2>&1
1188   if [ $? != 0 ]; then
1189     fatal_and_exit '-E- makexml -dvd *.VOB -out dvd failed'
1190   fi
1191
1192   # replace the first line of the xml file to remove the bad dest path
1193   awk -v line=1 -v new_content="<dvdauthor>" '{
1194     if (NR == line) {
1195       print new_content;
1196     } else {
1197       print $0;
1198     }
1199   }' dvd.xml > dvd.xml.new
1200   mv -f dvd.xml.new dvd.xml
1201   if [ $? != 0 ]; then
1202     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
1203   fi
1204
1205   # remove the "<video " property line from the xml file
1206   cat dvd.xml | grep -v "<video" > dvd.xml.new
1207   mv -f dvd.xml.new dvd.xml
1208   if [ $? != 0 ]; then
1209     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
1210   fi
1211   
1212   # remove the extra <pgc>..</pgc> pairs
1213   cat dvd.xml | awk 'BEGIN {x=1}
1214   {
1215     if ($0~"</pgc>") {x=0}
1216     if (x==1) {print $0}
1217     if ($0~"<pgc>") {x=1}
1218   }' > dvd.xml.new
1219   echo -e "</pgc>\n</titles>\n</titleset>\n</dvdauthor>" >> dvd.xml.new
1220   mv -f dvd.xml.new dvd.xml
1221   if [ $? != 0 ]; then
1222     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
1223   fi
1224
1225   # remove the VTS_*_0.VOB file as this is just the main menu video clip
1226   cat dvd.xml | grep -v "VTS_.*_0.VOB" > dvd.xml.new
1227   mv -f dvd.xml.new dvd.xml
1228   if [ $? != 0 ]; then
1229     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
1230   fi
1231 }
1232
1233 function check_for_mplayer_dumpstream_incompatibility {
1234
1235   echo "-> Checking for mplayer dumpstream incompatibilities" | tee -a "$logfile"
1236
1237   if [ ! -e "$vobfile" ]; then
1238     # mplayer dumpstream does not work on DVDs that obscure the feature title.
1239     # A DVD that has 99 titles, where the longest title isn't the main feature
1240     # breaks mplayer dumpstream. We have to fallback to using dvdbackup to figure
1241     # out what the feature title is. This script will run through that flow if we
1242     # set use_mplayer_dumpstream to 0. Check for this here.
1243     if [ $ripdvd -eq 1 ]; then
1244       lsdvd $dev | grep -q "Title: 99"
1245     else
1246       lsdvd "$isofile" | grep -q "Title: 99"
1247     fi
1248     # If we have 99 titles and a feature title wasn't given on the command line, switch modes.
1249     if [ $? == 0 ] && [ $feature_title_override -eq 0 ]; then
1250       if [ $trust_feature_title_autodetect_when_uncertain -eq 0 ]; then
1251         echo "-E- Unable to determine the feature title due to the 99 title copy protection scheme" | tee -a "$logfile"
1252         echo "    You will need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
1253         echo "    You can google this DVD to find out what it's feature title is, or you can play it in a conventional DVD player to find it." | tee -a "$logfile"
1254         invalid_feature_title=1
1255       else 
1256         echo "    Falling back to non mplayer dumpstream methods to copy the DVD" | tee -a "$logfile"
1257         echo "-W- We still may not be able to autodetect the right feature title" | tee -a "$logfile"
1258         echo "    You may need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
1259         use_mplayer_dumpstream=0
1260         invalid_feature_title=1
1261       fi
1262       return
1263     fi
1264   fi
1265
1266   # There is another form of protection that causes the mplayer dumpstream to fail. 
1267   # This can be detected by telling mplayer to parse the VOB file by copying its audio
1268   # video streams to a dummy output file (/dev/null). Do that here to check for that 
1269   # problem before continuing.
1270   if [ -e "$vobfile" ]; then
1271     mplayer_opts="-quiet -ofps 30000/1001 -ffourcc DIVX -oac copy -ovc copy"
1272     mencoder $mplayer_opts "$vobfile" -o "/dev/null" > $dumplog 2>&1
1273     grep -q "Too many audio packets in the buffer" $dumplog
1274     if [ $? == 0 ]; then
1275       echo "-> The VOB dumped by mplayer is invalid. Falling back to non mplayer dumpstream to copy the DVD" | tee -a "$logfile"
1276       use_mplayer_dumpstream=0
1277       mplayer_dumpstream_incompatibility=1
1278     fi
1279     [[ -e "$dumplog" ]] && rm -f $dumplog
1280   fi
1281 }
1282
1283 function fill_mythvideo_metadata {
1284
1285   # This function must be passed the filename as an argument
1286   # The filename must be a full path to the file
1287   filename="$1"
1288
1289   # Make sure the fill mythvideo metadata option has been set to 1
1290   if [ $fill_mythvideo_metadata -eq 0 ]; then
1291     echo "-> fill_mythvideo_metadata=0 therefore not updating mythvideo metadata for this rip" | tee -a "$logfile"
1292     return 0
1293   fi
1294
1295   # If the fill mythvideo metadata script is present, run it
1296   # fill_mythvideo_metadata.plThis will download the metadata for the DVD we ripped.
1297   if [[ -x `which fill_mythvideo_metadata.pl` ]]; then
1298     echo "-> Running fill_mythvideo_metadata.pl to lookup/add/update the metadata for this DVD: $filename" | tee -a "$logfile"
1299     fill_mythvideo_metadata.pl -N 0 -F "$filename" >> "$logfile" 2>&1
1300   else
1301     echo "-W- Unable to find the fill_mythvideo_metadata.pl script in your PATH. Unable to autofill the mythvideo DB for this rip." | tee -a "$logfile"
1302     echo "    Set the fill_mythvideo_metadata variable to 0 in the script to avoid running this step." | tee -a "$logfile"
1303   fi
1304 }
1305
1306 # remove the intermediate VOB file
1307 function remove_intermediate_vob_file {
1308   if [ $keep_intermediate_files -eq 0 ]; then
1309     [[ -e "$tmpdir/$dvdname.VOB" ]] && rm -f "$tmpdir/$dvdname.VOB"
1310   else
1311     echo "-> Keeping intermediate concatenated VOB file: $tmpdir/$dvdname.VOB" | tee -a "$logfile"
1312   fi
1313 }
1314
1315 # remove the original DVD image 
1316 function remove_intermediate_iso_file {
1317   [[ $keep_isofile -eq 1 ]] && return 1
1318   if [ $keep_intermediate_files -eq 0 ]; then
1319     [[ -e "$isofile" ]] && rm "$isofile"
1320   else
1321     echo "-> Keeping ddrescue intermediate iso file: $isofile" | tee -a "$logfile"
1322   fi
1323 }
1324
1325 # remove the intermediate dvdbackup folder
1326 function remove_intermediate_dvdbackup_folder {
1327   if [ $keep_intermediate_files -eq 0 ]; then
1328     [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
1329   else
1330     echo "-> Keeping intermediate dvdbackup folder: $tmpdir/$dvdname" | tee -a "$logfile"
1331   fi
1332 }
1333
1334 ##############################################################################################
1335 # MAIN
1336 ##############################################################################################
1337
1338 # Make a note of when this DVD rip started
1339 date=`date`
1340 echo -e "\n$date DVD rip started" >> "$logfile"
1341 echo "$cmd" >> "$logfile"
1342
1343 # Rip the DVD - Mirror Mode
1344 if [ $mirror_mode -eq 1 ]; then
1345   echo "-> Ripping DVD $dvdname to $dest"
1346
1347   # use ddrescue to make an ISO image of the disk
1348   make_dvd_iso_image "$dest/$dvdname.iso"
1349
1350   # add this video data to the mythtv DB
1351   fill_mythvideo_metadata "$dest/$dvdname.iso" 
1352
1353   # eject the disk upon completion
1354   if [ $eject_disk -ne 0 ]; then
1355     eject -T $dev
1356   fi
1357
1358   date=`date`
1359   echo "$date DVD rip completed" | tee -a "$logfile"
1360
1361   if [[ -n "$mailto" ]]; then
1362     cat "$logfile" | mailx -s "dvd rip of $dvdname DONE" "$mailto"
1363   fi
1364
1365 fi
1366
1367 # Rip the DVD - Main Title Feature Only
1368 if [ $mirror_mode -eq 0 ]; then
1369
1370   # Rip image from DVD
1371   if [ $ripdvd -eq 1 ]; then
1372     echo "-> Ripping DVD $dvdname to $dest" | tee -a "$logfile"
1373     # use ddrescue to make an ISO image of the disk
1374     make_dvd_iso_image "$tmpdir/$dvdname.iso"
1375   fi
1376
1377   # Rip image from DVD path
1378   if [ -n "$dvdpath" ]; then
1379     echo "-> Ripping DVD $dvdpath to $dest" | tee -a "$logfile"
1380     make_dvd_iso_image_from_folder "$dvdpath" "$tmpdir/$dvdname.iso" 1
1381   fi
1382
1383   # make sure our isofile value is set
1384   if [ -z "$isofile" ]; then
1385     isofile="$tmpdir/$dvdname.iso"
1386   fi
1387      
1388   if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_comp -eq 1 ]; then
1389
1390     if [ ! -e "$vobfile" ]; then
1391       echo "-> Creating DVD video $vobfile" | tee -a "$logfile"
1392       
1393       # get the feature title from the ISO
1394       get_feature_title "$isofile"
1395  
1396       # get the crop value from the ISO
1397       get_crop_from_iso
1398
1399       # check for mplayer dumpstream incompatibilities
1400       # if they exist, this method will set this mode to 0.
1401       check_for_mplayer_dumpstream_incompatibility
1402
1403       if [ $use_mplayer_dumpstream -eq 1 ]; then 
1404
1405         # get our audio id from the ISO file
1406         get_audio_id_from_iso "$isofile"
1407
1408         # create our main VOB file from the ISO
1409         create_main_vob_with_mplayer "$isofile"
1410      
1411         # remove the intermediate VOB file
1412         remove_intermediate_vob_file
1413
1414         # it's possible that our VOB is still corrupted in some manner
1415         # check to make sure it is still a good VOB before continuing.
1416         check_for_mplayer_dumpstream_incompatibility
1417
1418       fi
1419  
1420       if [ $use_mplayer_dumpstream -eq 0 ]; then 
1421
1422         # use dvdbackup to make a DVD folder of the feature title
1423         make_dvdbackup_folder_image
1424   
1425         # create our main VOB file
1426         create_main_vob_with_cat
1427
1428         # get our audio id from the VOB file
1429         get_audio_id_from_vob "$tmpdir/$dvdname.VOB"
1430   
1431         # check for corrupted VOB start
1432         check_vob_for_corrupted_start
1433  
1434         # check to make sure our VOB is complete
1435         check_vob_for_completeness
1436
1437         # check to make sure our VOB doesn't have too many video packets
1438         check_vob_for_too_many_video_packets
1439
1440         # check to make sure our VOB doesn't have a52 crc errors
1441         check_vob_for_a52_crc_errors
1442
1443         # remove the intermediate VOB file
1444         remove_intermediate_vob_file
1445
1446       fi
1447
1448       # remove the intermediate ISO file
1449       remove_intermediate_iso_file
1450
1451     else
1452       if [ "$encoder" != "handbrake" ]; then 
1453         echo "-> Skipping VOB creation. VOB DVD video already exists: $vobfile" | tee -a "$logfile"
1454         # get our audio id from the VOB file
1455         get_audio_id_from_vob "$vobfile"
1456         # get the crop value from the VOB
1457         get_crop_from_vob
1458       fi
1459     fi
1460
1461     # eject the DVD disk since we are finished with it
1462     [ $eject_disk -eq 2 ] && eject -T $dev
1463
1464     # encode the VOB file to a compressed file format
1465     if [ $make_final_dest_comp -eq 1 ]; then
1466       echo "-> Encoding the DVD video to a compressed file using $encoder" | tee -a "$logfile"
1467
1468       # determine what our bitrate needs to be if a target size was specified instead
1469       calculate_bitrate_from_target_size        
1470      
1471       # encode the vob file into a compressed file format
1472       if [[ "$encoder" == "mencoder" ]]; then 
1473         encode_vob_file_mencoder
1474       fi
1475       if [[ "$encoder" == "handbrake" ]]; then
1476         encode_vob_file_handbrake
1477       fi
1478
1479       if [ $keep_intermediate_files -eq 0 ] && [ $make_final_dest_vob -eq 0 ]; then
1480         [[ -e "$vobfile" ]] && [[ $keep_vobfile -eq 0 ]] && rm -f "$vobfile";
1481         [[ -e "$passlogfile" ]] && rm -f "$passlogfile";
1482       else
1483         echo "-> Keeping VOB file: $vobfile" | tee -a "$logfile"
1484         echo "-> Keeping mencoder 2pass logfile: $passlogfile"
1485       fi
1486     fi
1487
1488   # add this video data to the mythtv DB
1489   [ $make_final_dest_comp -eq 1 ] && fill_mythvideo_metadata "$final_output_file" 
1490   [ $make_final_dest_vob -eq 1 ] && fill_mythvideo_metadata "$vobfile" 
1491     
1492   else
1493
1494   # use dvdbackup to make a DVD folder of the feature title
1495   make_dvdbackup_folder_image
1496
1497   # cd to the feature title DVD folder
1498   pushd "$tmpdir/$dvdname/VIDEO_TS" > /dev/null 2>&1
1499   if [ $? != 0 ]; then
1500     fatal_and_exit "-E- Unable to cd to $tmpdir/$dvdname/VIDEO_TS"
1501   fi
1502   
1503   # create the dvd.xml file for dvdauthor
1504   create_dvdauthor_dvd_xml_file  
1505
1506   # make the final DVD folder image
1507   make_dvdauthor_folder_image
1508
1509   # add this video data to the mythtv DB
1510   fill_mythvideo_metadata "$dest/$dvdname/VIDEO_TS" 
1511  
1512   # cd back to the dir we started from
1513   popd > /dev/null 2>&1
1514
1515   if [ $make_final_dest_iso -eq 1 ]; then
1516
1517     # make an iso image out of our directory
1518     make_dvd_iso_image_from_folder "$dest/$dvdname" "$dest/$dvdname.iso" 0
1519    
1520     # If the mkisofs was unable to make a .iso file for us, don't remove the DVD directory 
1521     if [ -s "$dest/$dvdname.iso" ]; then
1522       if [ $make_final_dest_folder -eq 0 ]; then
1523         echo "-> Removing DVD folder since ISO was created: $dest/$dvdname" | tee -a "$logfile"
1524         # remove the folder of the DVD image now that we have a .iso version of it
1525         [[ -d "$dest/$dvdname" ]] && rm -rf "$dest/$dvdname"
1526       fi
1527     else
1528       # we created an empty iso file, remove it
1529       echo "-> Removing empty ISO image: $dest/$dvdname.iso" | tee -a "$logfile"
1530       echo "-> Keeping the DVD folder since the ISO image couldn't be created properly: $dest/$dvdname"
1531       [[ -e "$dest/$dvdname.iso" ]] && rm "$dest/$dvdname.iso"
1532     fi
1533  
1534     # add this video data to the mythtv DB
1535     fill_mythvideo_metadata "$dest/$dvdname.iso" 
1536
1537   fi
1538
1539   fi
1540
1541   # remove the ddrescue DVD ISO image
1542   remove_intermediate_iso_file
1543
1544   # remove the tmp dvdbackup folder of the DVD image
1545   remove_intermediate_dvdbackup_folder
1546
1547   # eject the DVD disk upon completion
1548   [ $eject_disk -eq 1 ] && eject -T $dev
1549
1550   date=`date`
1551   echo "$date DVD rip completed" | tee -a "$logfile"
1552
1553   if [[ -n "$mailto" ]]; then
1554     cat "$logfile" | mailx -s "dvd rip of $dvdname DONE" "$mailto"
1555   fi
1556
1557 fi
1558
1559 ##############################################################################################